"""
    IRN API v1

    Allows users to extract, create, update and configure IRN data.  # noqa: E501

    The version of the OpenAPI document: 1
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.IRNConfiguration.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.IRNConfiguration.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.IRNConfiguration.model.date_settings_dto import DateSettingsDto
    from fds.sdk.IRNConfiguration.model.identifier_settings_dto import IdentifierSettingsDto
    from fds.sdk.IRNConfiguration.model.link_settings_dto import LinkSettingsDto
    from fds.sdk.IRNConfiguration.model.note_settings_dto import NoteSettingsDto
    from fds.sdk.IRNConfiguration.model.organizer_settings_dto import OrganizerSettingsDto
    from fds.sdk.IRNConfiguration.model.recommendation_settings_dto import RecommendationSettingsDto
    from fds.sdk.IRNConfiguration.model.related_contacts_settings_dto import RelatedContactsSettingsDto
    from fds.sdk.IRNConfiguration.model.related_research_settings_dto import RelatedResearchSettingsDto
    from fds.sdk.IRNConfiguration.model.related_symbols_settings_dto import RelatedSymbolsSettingsDto
    from fds.sdk.IRNConfiguration.model.sentiment_settings_dto import SentimentSettingsDto
    from fds.sdk.IRNConfiguration.model.source_settings_dto import SourceSettingsDto
    from fds.sdk.IRNConfiguration.model.subject_settings_dto import SubjectSettingsDto
    from fds.sdk.IRNConfiguration.model.team_settings_dto import TeamSettingsDto
    from fds.sdk.IRNConfiguration.model.title_settings_dto import TitleSettingsDto
    globals()['DateSettingsDto'] = DateSettingsDto
    globals()['IdentifierSettingsDto'] = IdentifierSettingsDto
    globals()['LinkSettingsDto'] = LinkSettingsDto
    globals()['NoteSettingsDto'] = NoteSettingsDto
    globals()['OrganizerSettingsDto'] = OrganizerSettingsDto
    globals()['RecommendationSettingsDto'] = RecommendationSettingsDto
    globals()['RelatedContactsSettingsDto'] = RelatedContactsSettingsDto
    globals()['RelatedResearchSettingsDto'] = RelatedResearchSettingsDto
    globals()['RelatedSymbolsSettingsDto'] = RelatedSymbolsSettingsDto
    globals()['SentimentSettingsDto'] = SentimentSettingsDto
    globals()['SourceSettingsDto'] = SourceSettingsDto
    globals()['SubjectSettingsDto'] = SubjectSettingsDto
    globals()['TeamSettingsDto'] = TeamSettingsDto
    globals()['TitleSettingsDto'] = TitleSettingsDto


class GroupFieldsDto(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'title': (TitleSettingsDto,),  # noqa: E501
            'date': (DateSettingsDto,),  # noqa: E501
            'identifier': (IdentifierSettingsDto,),  # noqa: E501
            'subject': (SubjectSettingsDto,),  # noqa: E501
            'recommendation': (RecommendationSettingsDto,),  # noqa: E501
            'sentiment': (SentimentSettingsDto,),  # noqa: E501
            'link': (LinkSettingsDto,),  # noqa: E501
            'note': (NoteSettingsDto,),  # noqa: E501
            'source': (SourceSettingsDto,),  # noqa: E501
            'related_symbols': (RelatedSymbolsSettingsDto,),  # noqa: E501
            'related_research': (RelatedResearchSettingsDto,),  # noqa: E501
            'related_contacts': (RelatedContactsSettingsDto,),  # noqa: E501
            'team': (TeamSettingsDto,),  # noqa: E501
            'organizer': (OrganizerSettingsDto,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'title': 'Title',  # noqa: E501
        'date': 'Date',  # noqa: E501
        'identifier': 'Identifier',  # noqa: E501
        'subject': 'Subject',  # noqa: E501
        'recommendation': 'Recommendation',  # noqa: E501
        'sentiment': 'Sentiment',  # noqa: E501
        'link': 'Link',  # noqa: E501
        'note': 'Note',  # noqa: E501
        'source': 'Source',  # noqa: E501
        'related_symbols': 'RelatedSymbols',  # noqa: E501
        'related_research': 'RelatedResearch',  # noqa: E501
        'related_contacts': 'RelatedContacts',  # noqa: E501
        'team': 'Team',  # noqa: E501
        'organizer': 'Organizer',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """GroupFieldsDto - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            title (TitleSettingsDto): [optional]  # noqa: E501
            date (DateSettingsDto): [optional]  # noqa: E501
            identifier (IdentifierSettingsDto): [optional]  # noqa: E501
            subject (SubjectSettingsDto): [optional]  # noqa: E501
            recommendation (RecommendationSettingsDto): [optional]  # noqa: E501
            sentiment (SentimentSettingsDto): [optional]  # noqa: E501
            link (LinkSettingsDto): [optional]  # noqa: E501
            note (NoteSettingsDto): [optional]  # noqa: E501
            source (SourceSettingsDto): [optional]  # noqa: E501
            related_symbols (RelatedSymbolsSettingsDto): [optional]  # noqa: E501
            related_research (RelatedResearchSettingsDto): [optional]  # noqa: E501
            related_contacts (RelatedContactsSettingsDto): [optional]  # noqa: E501
            team (TeamSettingsDto): [optional]  # noqa: E501
            organizer (OrganizerSettingsDto): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """GroupFieldsDto - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            title (TitleSettingsDto): [optional]  # noqa: E501
            date (DateSettingsDto): [optional]  # noqa: E501
            identifier (IdentifierSettingsDto): [optional]  # noqa: E501
            subject (SubjectSettingsDto): [optional]  # noqa: E501
            recommendation (RecommendationSettingsDto): [optional]  # noqa: E501
            sentiment (SentimentSettingsDto): [optional]  # noqa: E501
            link (LinkSettingsDto): [optional]  # noqa: E501
            note (NoteSettingsDto): [optional]  # noqa: E501
            source (SourceSettingsDto): [optional]  # noqa: E501
            related_symbols (RelatedSymbolsSettingsDto): [optional]  # noqa: E501
            related_research (RelatedResearchSettingsDto): [optional]  # noqa: E501
            related_contacts (RelatedContactsSettingsDto): [optional]  # noqa: E501
            team (TeamSettingsDto): [optional]  # noqa: E501
            organizer (OrganizerSettingsDto): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
